/**
 * Copyright (C) 2000  Johan Redestig, Anders Palsson
 *
 * This library is free software; you can redistribute it and/or
 * modify it under the terms of the GNU Lesser General Public
 * License as published by the Free Software Foundation; either
 * version 2.1 of the License, or (at your option) any later version.
 * 
 * This library is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * Lesser General Public License for more details.
 *
 * You should have received a copy of the GNU Lesser General Public
 * License along with this library; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 */

/**
 * A simple example user.
 */
public class User
{
      protected String fullname;
      protected String username;
      protected String password;

      /**
       * 
       */
      public User()
      {
         this(null, null, null);
      }

      /**
       * Creates a new user with the specified fullname, username and password.
       */
      public User(String fullname, String username, String password)
      {
         this.fullname = fullname;
         this.username = username;
         this.password = password;
      }

      /**
       * Returns this user's username.
       */
      public String getUsername()
      {
         return username;
      }

      /**
       * Returns this user's full name.
       */
      public String getFullname()
      {
         return fullname;
      }

      /**
       * Returns this user's password.
       */
      public String getPassword()
      {
         return password;
      }
         
}
