/**
 * Copyright (C) 2000  Johan Redestig, Anders Palsson
 *
 * This library is free software; you can redistribute it and/or
 * modify it under the terms of the GNU Lesser General Public
 * License as published by the Free Software Foundation; either
 * version 2.1 of the License, or (at your option) any later version.
 * 
 * This library is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * Lesser General Public License for more details.
 *
 * You should have received a copy of the GNU Lesser General Public
 * License along with this library; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 */
package org.codemode.bishop.entity;

import org.codemode.bishop.BishopEntity;
import org.codemode.bishop.Model;
import org.codemode.bishop.Scope;
import org.codemode.bishop.BishopException;
import java.util.Map;
import java.util.Enumeration;

public class Catch extends BishopEntity
{
      protected static final String NAME = "name";
      protected static final String TYPE = "type";
      
      protected Class exception;
      
      /**
       *
       */
      public void invoke(Scope locals, org.codemode.bishop.View view, Model model) throws Throwable
      {
         invokeAllChildren(locals, view, model);
      }

      /**
       *
       */         
      public Class getException() throws BishopException
      {
         if(exception == null)
         {
            try
            {
               exception = Class.forName((String)attributes.get(TYPE));
            }
            catch(Exception e)
            {
               throw new BishopException(e, this, "No such class for exception");
            }
         }
         return exception;
      }

      /**
       *
       */
      public String getName()
      {
         return (String)attributes.get(NAME);
      }
       
}
