/**
 * Copyright (C) 2000  Johan Redestig, Anders Palsson
 *
 * This library is free software; you can redistribute it and/or
 * modify it under the terms of the GNU Lesser General Public
 * License as published by the Free Software Foundation; either
 * version 2.1 of the License, or (at your option) any later version.
 * 
 * This library is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * Lesser General Public License for more details.
 *
 * You should have received a copy of the GNU Lesser General Public
 * License along with this library; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 */
package org.codemode.bishop.entity;

import org.codemode.bishop.BishopEntity;
import org.codemode.bishop.Model;
import org.codemode.bishop.Scope;
import org.codemode.bishop.BishopException;

import java.util.Map;
import java.util.Enumeration;
import java.util.Vector;

import org.log4j.Category;

/**
 *
 */
public class Try extends BishopEntity
{
      Vector catches = new Vector();
      Category cat = Category.getInstance(BishopEntity.class.getName());

      public void invoke(Scope locals, org.codemode.bishop.View view, Model model) throws Throwable
      {
         try
         {
            invokeAllChildren(locals, view, model);
         }
         catch(Throwable e)
         {
            Enumeration c = catches.elements();
            while(c.hasMoreElements())
            {
               Catch _catch = (Catch)c.nextElement();

               if (_catch.getException().isAssignableFrom(e.getClass()))
               {
                  if(e instanceof BishopException)
                  {
                     cat.debug("Try caught BishopException (this might be ok) ", e);
                     cat.debug("Bishop stack: " + getStackTrace());                     
                  }
                  
                  locals.putObject(_catch.getName(), e);
                  _catch.invoke(locals, view, model);
                  break;
               }
            }
         }
      }

      public void addChild(BishopEntity child)
      {
         if(child instanceof Catch)
         {
            catches.add(child);
         }
         else 
         {
            super.addChild(child);
         }
      }
}
