/**
 * Copyright (C) 2000  Johan Redestig, Anders Palsson
 *
 * This library is free software; you can redistribute it and/or
 * modify it under the terms of the GNU Lesser General Public
 * License as published by the Free Software Foundation; either
 * version 2.1 of the License, or (at your option) any later version.
 * 
 * This library is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * Lesser General Public License for more details.
 *
 * You should have received a copy of the GNU Lesser General Public
 * License along with this library; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 */
package org.codemode.bishop.entity;

import org.codemode.bishop.BishopEntity;
import org.codemode.bishop.Model;
import org.codemode.bishop.Scope;

/**
 * 
 */
public class View extends BishopEntity
{
      public static final String NAME = "name";
      public static final String TEMPLATE = "template";
      
      /**
       * 
       */
      public void invoke(Scope locals, org.codemode.bishop.View view, Model model) throws Throwable
      {
         String name = (String)attributes.get(NAME);
         String template = (String)attributes.get(TEMPLATE);

         System.out.println("View.invoke name: " + name + " template: " + template);

         // get the name of the template from locals (if defined), else use default..
         if (locals.getObject(template) != null)
         {
            template = (String)locals.getObject(template);
         }
          
         if (name != null)
         {
            view.addSubView(name, template);
         }
         else
         {
            view.setRootTemplate(template);
         }
      }
}
